regina::AngleStructure Class Reference
Angle Structures

Represents an angle structure on a triangulation. More...

`#include <angle/anglestructure.h>`

Inheritance diagram for regina::AngleStructure:

## Public Member Functions

| AngleStructure (const Triangulation< 3 > *triang, AngleStructureVector *newVector)
| Creates a new angle structure on the given triangulation with the given coordinate vector. More...
| ~AngleStructure ()
| Destroys this angle structure. More...
AngleStructure * | clone () const
| Creates a newly allocated clone of this angle structure. More...
Rational | angle (size_t tetIndex, int edgePair) const
| Returns the requested angle in this angle structure. More...
const Triangulation< 3 > * | triangulation () const
| Returns the triangulation on which this angle structure lies. More...
bool | isStrict () const
| Determines whether this is a strict angle structure. More...
bool | isTaut () const
| Determines whether this is a taut angle structure. More...
bool | isVeering () const
| Determines whether this is a veering structure. More...
const AngleStructureVector * | rawVector () const
| Gives read-only access to the raw vector that sits beneath this angle structure. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeXMLData (std::ostream &out) const
| Writes a chunk of XML containing this angle structure and all of its properties. More...
void | writeTextLong (std::ostream &out) const
| A default implementation for detailed output. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Protected Member Functions

void | calculateType () const
| Calculates the structure type (strict or taut) and stores it as a property. More...

## Friends

class | regina::XMLAngleStructureReader

## Detailed Description

Represents an angle structure on a triangulation.

Once the underlying triangulation changes, this angle structure is no longer valid.

## Constructor & Destructor Documentation

## AngleStructure()

regina::AngleStructure::AngleStructure | ( | const Triangulation< 3 > * | triang,
|  | AngleStructureVector * | newVector
| ) |  |

inline

Creates a new angle structure on the given triangulation with the given coordinate vector.

Python:
  Not present.

Parameters

  triang | the triangulation on which this angle structure lies.
  newVector | a vector containing the individual angles in the angle structure.

## ~AngleStructure()

regina::AngleStructure::~AngleStructure | ( |  | ) |

inline

Destroys this angle structure.

The underlying vector of angles will also be deallocated.

## Member Function Documentation

## angle()

Rational regina::AngleStructure::angle | ( | size_t | tetIndex,
|  | int | edgePair
| ) |  | const

Returns the requested angle in this angle structure.

The angle returned will be scaled down; the actual angle is the returned value multiplied by pi.

Within a tetrahedron, the three angles are indexed 0, 1 and 2. Angle i appears on edge i of the tetrahedron as well as its opposite edge (5-i).

Parameters

  tetIndex | the index in the triangulation of the tetrahedron in which the requested angle lives; this should be between 0 and Triangulation<3>::size()-1 inclusive.
  edgePair | the number representing the pair of edges holding the requested angle, as described above; this should be 0, 1 or 2.

Returns
  the requested angle scaled down by pi.

## calculateType()

void regina::AngleStructure::calculateType | ( |  | ) | const

protected

Calculates the structure type (strict or taut) and stores it as a property.

## clone()

AngleStructure* regina::AngleStructure::clone | ( |  | ) | const

Creates a newly allocated clone of this angle structure.

Returns
  a clone of this angle structure.

## detail()

std::string regina::Output< AngleStructure , supportsUtf8 >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## isStrict()

bool regina::AngleStructure::isStrict | ( |  | ) | const

inline

Determines whether this is a strict angle structure.

A strict angle structure has all angles strictly between (not including) 0 and pi.

Returns
  `true` if and only if this is a strict angle structure.

## isTaut()

bool regina::AngleStructure::isTaut | ( |  | ) | const

inline

Determines whether this is a taut angle structure.

A taut angle structure contains only angles 0 and pi.

Here we use the Kang-Rubinstein definition of a taut angle structure [1], which is based on the angles alone. In his original paper [2], Lackenby has an extra condition whereby 2-faces of the triangulation must have consistent coorientations, which we do not enforce here.

[1] E. Kang and J. H. Rubinstein, "Ideal triangulations of 3-manifolds II; Taut and angle structures", Algebr. Geom. Topol. 5 (2005), pp. 1505-1533.

[2] M. Lackenby, "Taut ideal triangulations of 3-manifolds", Geom. Topol. 4 (2000), pp. 369-395.

Returns
  `true` if and only if this is a taut structure.

## isVeering()

bool regina::AngleStructure::isVeering | ( |  | ) | const

inline

Determines whether this is a veering structure.

A veering structure is taut angle structure with additional strong combinatorial constraints, which we do not outline here. For a definition, see C. D. Hodgson, J. H. Rubinstein, H. Segerman, and S. Tillmann, "Veering triangulations admit strict angle structures", Geom. Topol., 15 (2011), pp. 2073-2089.

Note that the Hodgson et al. definition is slightly more general than Agol's veering taut triangulations from his original paper: I. Agol, " Ideal triangulations of pseudo-Anosov mapping tori", in "Topology and Geometry in Dimension Three", volume 560 of Contemp. Math., pp. 1-17, Amer. Math. Soc., 2011. This mirrors the way in which the Kang-Rubinstein definition of taut angle structure is slightly more general than Lackenby's. See the Hodgson et al. paper for full details and comparisons between the two settings.

If this angle structure is not taut, or if the underlying triangulation is non-orientable, then this routine will return `false`.

Returns
  `true` if and only if this is a veering structure.

## rawVector()

const AngleStructureVector * regina::AngleStructure::rawVector | ( |  | ) | const

inline

Gives read-only access to the raw vector that sits beneath this angle structure.

Generally users should not need this function. However, it is provided here in case the need should arise (e.g., for reasons of efficiency).

Python:
  Not present.

Returns
  the underlying raw vector.

## str()

std::string regina::Output< AngleStructure , supportsUtf8 >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:
  In addition to str(), this is also used as the Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## triangulation()

const Triangulation< 3 > * regina::AngleStructure::triangulation | ( |  | ) | const

inline

Returns the triangulation on which this angle structure lies.

Returns
  the underlying triangulation.

## utf8()

std::string regina::Output< AngleStructure , supportsUtf8 >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

## writeTextLong()

void regina::ShortOutput< AngleStructure , false >::writeTextLong | ( | std::ostream & | out | ) | const

inline inherited

A default implementation for detailed output.

This routine simply calls T::writeTextShort() and appends a final newline.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## writeTextShort()

void regina::AngleStructure::writeTextShort | ( | std::ostream & | out | ) | const

Writes a short text representation of this object to the given output stream.

Python:
  Not present.

Parameters

  out | the output stream to which to write.

## writeXMLData()

void regina::AngleStructure::writeXMLData | ( | std::ostream & | out | ) | const

Writes a chunk of XML containing this angle structure and all of its properties.

This routine will be called from within AngleStructures::writeXMLPacketData().

Python:
  Not present.

Parameters

  out | the output stream to which the XML should be written.

The documentation for this class was generated from the following file:

- angle/anglestructure.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).